package com.onfise.ibhaan_aes;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** IbhaanAesPlugin */
public class IbhaanAesPlugin implements MethodCallHandler {
  MethodChannel methodChannel;
  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "ibhaan_aes");
    channel.setMethodCallHandler(new IbhaanAesPlugin(channel));
  }

  public IbhaanAesPlugin(MethodChannel methodChannel) {
    this.methodChannel = methodChannel;
    this.methodChannel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    switch(call.method) {
      case "getPlatformVersion":
        result.success("Android " + android.os.Build.VERSION.RELEASE);
        break;
      case "doDecrypt":
        String stringToDecrypt=call.argument("stringToDecrypt");
        String key=call.argument("key");
        String iv=call.argument("iv");
        result.success(decrypt(stringToDecrypt,key,iv));
        break;
        default:
          result.notImplemented();
          break;
    }
  }

  private String decrypt(String encryptedText,String key,String iv) {
    String decryptedText = "";
    try {
      final String characterEncoding       = "UTF-8";
      final String cipherTransformation    = "AES/CBC/PKCS5PADDING";
      final String encryptionAlgorithm = "AES";
      Cipher cipher = Cipher.getInstance(cipherTransformation);
      byte[] keyBytes = key.getBytes(characterEncoding);
      byte[] ivBytes = iv.getBytes(characterEncoding);
      SecretKeySpec secretKey = new SecretKeySpec(keyBytes,encryptionAlgorithm);
      IvParameterSpec ivparameterspec = new IvParameterSpec(ivBytes);
      cipher.init(Cipher.DECRYPT_MODE, secretKey, ivparameterspec);
      byte[] cipherText =
        android.util.Base64.decode(encryptedText.getBytes(characterEncoding),
          android.util.Base64.DEFAULT);
      decryptedText = new String(cipher.doFinal(cipherText),characterEncoding);
    } catch (Exception E) {
      System.err.println("decrypt Exception : "+E.getMessage());
      decryptedText="Could not decrypt your text";
    }
    return decryptedText;
  }
}
