import Flutter
import UIKit
import Foundation
import CommonCrypto

public class SwiftIbhaanAesPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "ibhaan_aes", binaryMessenger: registrar.messenger())
    let instance = SwiftIbhaanAesPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
    case "getPlatformVersion":
        result("iOS " + UIDevice.current.systemVersion)
        break;
    case "doDecrypt":
        guard let args = call.arguments else {
            result("Arguments not received")
            return
        }
        if let myArgs = args as? [String: Any],
            let stringToDecrypt = myArgs["stringToDecrypt"] as? String,
            let key = myArgs["key"] as? String,
            let iv = myArgs["iv"] as? String {
            result(decrypt(stringToDecrypt: stringToDecrypt, key: key, iv: iv))
        } else {
            result("Incorrect arguments")
        }
        break;
    default:
        result("Method not implemented")
    }
  }
    
    private func decrypt(stringToDecrypt:String,key:String,iv:String) -> String {
        //let stringToDecrypt = "v1m3zT1nClLOKkB4FynH/jkumiy2tsybYBklh/iv5O8NzpzkoIu42TOAqsjiXLzh"
        let key128   = key //"Ibh@@nDigi7@1Ed1"                   // 16 bytes for AES128
        //let key256   = "12345678901234561234567890123456"   // 32 bytes for AES256
        //let iv       = "Ibh@@nDigi7@1Ed1"                   // 16 bytes for AES128
        
        let aes128 = AES(key: key128, iv: iv)
        //let aes256 = AES(key: key256, iv: iv)
        
        //let encryptedPassword128 = aes128?.encrypt(string: password)
        //print(encryptedPassword128)
        //print(aes128?.decrypt(data: encryptedPassword128))
        let decryptedString=aes128?.decrypt(data: Data(base64Encoded: stringToDecrypt))
        print(decryptedString!)
        return decryptedString!
    }
    
    struct AES {
        // MARK: - Value
        // MARK: Private
        private let key: Data
        private let iv: Data
        
        
        // MARK: - Initialzier
        init?(key: String, iv: String) {
            guard key.count == kCCKeySizeAES128 || key.count == kCCKeySizeAES256, let keyData = key.data(using: .utf8) else {
                debugPrint("Error: Failed to set a key.")
                return nil
            }
            
            guard iv.count == kCCBlockSizeAES128, let ivData = iv.data(using: .utf8) else {
                debugPrint("Error: Failed to set an initial vector.")
                return nil
            }
            
            
            self.key = keyData
            self.iv  = ivData
        }
        
        
        // MARK: - Function
        // MARK: Public
        func encrypt(string: String) -> Data? {
            return crypt(data: string.data(using: .utf8), option: CCOperation(kCCEncrypt))
        }
        
        func decrypt(data: Data?) -> String? {
            guard let decryptedData = crypt(data: data, option: CCOperation(kCCDecrypt)) else {
                return nil
            }
            return String(bytes: decryptedData, encoding: .utf8)
        }
        
        func crypt(data: Data?, option: CCOperation) -> Data? {
            guard let data = data else { return nil }
            
            let cryptLength = [UInt8](repeating: 0, count: data.count + kCCBlockSizeAES128).count
            var cryptData   = Data(count: cryptLength)
            
            let keyLength = [UInt8](repeating: 0, count: kCCBlockSizeAES128).count
            let options   = CCOptions(kCCOptionPKCS7Padding)
            
            var bytesLength = Int(0)
            
            let status = cryptData.withUnsafeMutableBytes { cryptBytes in
                data.withUnsafeBytes { dataBytes in
                    iv.withUnsafeBytes { ivBytes in
                        key.withUnsafeBytes { keyBytes in
                            CCCrypt(option, CCAlgorithm(kCCAlgorithmAES), options, keyBytes, keyLength, ivBytes, dataBytes, data.count, cryptBytes, cryptLength, &bytesLength)
                        }
                    }
                }
            }
            
            guard UInt32(status) == UInt32(kCCSuccess) else {
                debugPrint("Error: Failed to crypt data. Status \(status)")
                return nil
            }
            
            cryptData.removeSubrange(bytesLength..<cryptData.count)
            return cryptData
        }
    }
}
